export class Point {
    constructor(x, y){
        this.x = x;
        this.y = y;
    }

    scale(x, y) {
        this.x *= x;
        this.y *= y;
    }

    difference(point){
        return new Point(this.x - point.x, this.y - point.y)
    }

    snapToGrid(grid) {
        let pointOnGrid = new Point(
            Math.round(this.x / grid.width),
            Math.round(this.y / grid.height),
        )
        this.x = pointOnGrid.x * grid.width
        this.y = pointOnGrid.y * grid.height
    }

    snapToSpritesheetGrid(grid) {
        let pointOnGrid = new Point(
            Math.floor(this.x / (grid.width + grid.margin)),
            Math.floor(this.y / (grid.height + grid.margin)),
        )

        this.x = pointOnGrid.x * (grid.width + grid.margin)
        this.y = pointOnGrid.y * (grid.height + grid.margin)
    }
}