using System;
using System.Net.WebSockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace gameapi.Commands
{
    public class ConnectWebsocketCommand : IWebsocketCommand
    {
        private string[] keys;

        public ConnectWebsocketCommand(string[] keys)
        {
            this.keys = keys;
        }

        public async Task Run(WebSocket webSocket)
        {
            var message = string.Format("connect {0}", webSocket.GetHashCode());
            await webSocket.SendAsync(new ArraySegment<byte>(Encoding.UTF8.GetBytes(message), 0, message.Length), WebSocketMessageType.Text, true, CancellationToken.None);
        }
    }
}