using System;
using System.Net.WebSockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace gameapi.Commands
{
    public class EchoWebsocketCommand : IWebsocketCommand
    {
        private string commandString;

        public EchoWebsocketCommand(string commandString)
        {
            this.commandString = commandString;
        }

        public async Task Run(WebSocket webSocket)
        {
            await webSocket.SendAsync(new ArraySegment<byte>(Encoding.UTF8.GetBytes(commandString), 0, commandString.Length), WebSocketMessageType.Text, true, CancellationToken.None);
        }
    }
}