using System;
using System.Net.WebSockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using gameapi.Library;

namespace gameapi.Commands
{
    public class JoinWebsocketCommand : IWebsocketCommand
    {
        private string[] keys;
        private GameState state;

        public JoinWebsocketCommand(string[] keys)
        {
            this.keys = keys;
            this.state = GameState.GetInstance();
        }

        public async Task Run(WebSocket webSocket)
        {
            var player = this.state.GetPlayerBySocket(webSocket);
            Tuple<int, int> sector = new Tuple<int, int>(Int32.Parse(this.keys[1]), Int32.Parse(this.keys[2]));

            await this.state.EnterSector(player, sector);
        }
    }
}