using System;
using System.Drawing;
using System.Net.WebSockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using gameapi.Library;

namespace gameapi.Commands
{
	public class MoveWebsocketCommand : IWebsocketCommand
	{
		private string[] keys;
		private GameState state;

		public MoveWebsocketCommand(string[] keys)
		{
			this.keys = keys;
			this.state = GameState.GetInstance();
		}

		public async Task Run(WebSocket webSocket)
		{
			var player = this.state.GetPlayerBySocket(webSocket);
			player.SetPositionData(
				double.Parse(this.keys[1]),
				double.Parse(this.keys[2]),
				double.Parse(this.keys[3]),
				double.Parse(this.keys[4]),
				double.Parse(this.keys[5]),
				bool.Parse(this.keys[6])
			);
			await Task.CompletedTask;
		}
	}
}