
using System.Collections.Generic;
using System.Text.Json;

namespace gameapi.Library
{

	public class User
	{
		public User(string id, string displayname, string password, string email, List<string> permissions, string version = "1")
		{
			this.id = id;
			this.displayname = displayname;
			this.password = password;
			this.email = email;
			this.permissions = permissions;
			this.version = version;
		}
		public string id { get; }
		public string version { get; }
		public string displayname { get; }
		public string password { get; }
		public string email { get; }

		public List<string> permissions { get; }

		public static User Parse(JsonElement element) {
			var permissions = new List<string>();
			foreach (JsonElement permission in element.GetProperty("permissions").EnumerateArray())
			{
				permissions.Add(permission.ToString());
			}
			return new User(
				element.GetProperty("id").ToString(),
				element.GetProperty("displayname").ToString(),
				element.GetProperty("password").ToString(),
				element.GetProperty("email").ToString(),
				permissions,
				element.GetProperty("version").ToString()
			);
		}
	}
}